                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /* version 10: proper tail recursion */
                     /*-----------------------------------*/
                     /*              threads              */
                     /*-----------------------------------*/

#include "SlipMain.h"
#include "SlipThread.h"

/*------------------------------ private constants ---------------------------*/

enum { Thread_table_size = 19 };

static const TXT_type TMT_error_string = "too many thread registrations";

/*------------------------------ private variables ---------------------------*/

static CNT_type Current_thread;

static CCC_type Thread_table[Thread_table_size];
static UNS_type Thread_counter;

/*------------------------------ public functions ----------------------------*/

NIL_type Thread_Clear(NIL_type)
  { Current_thread = Main_Empty_Continuation; }

NIL_type Thread_Initialize(NIL_type)
  { Current_thread = Main_Empty_Continuation;
    Thread_counter = 0;
    Main_Register((REF_type)&Current_thread); }

CNT_type Thread_Keep(NIL_type)
  { return Current_thread; }

CNT_type Thread_Patch(NBR_type Thread_id)
  { Current_thread->tid = Thread_id; 
    return Current_thread; }

CNT_type Thread_Peek(NIL_type)
  { return Current_thread; }

CNT_type Thread_Poke(NBR_type Thread_id,
                     EXP_type Call_status,
                     UNS_type Size)
  { CNT_type continuation;
    continuation = Current_thread->cnt;
    continuation = make_CNT(Thread_id,
                            continuation,
                            Call_status,
                            Size);
    Current_thread = continuation;
    return continuation; }
        
CNT_type Thread_Pop(NIL_type)
  { CNT_type continuation;
    continuation = Current_thread;
    Current_thread = Current_thread->cnt;
    return continuation; }

CNT_type Thread_Push(NBR_type Thread_id,
                     EXP_type Call_status,
                     UNS_type Size)
  { CNT_type continuation;
    continuation = make_CNT(Thread_id,
                            Current_thread,
                            Call_status,
                            Size);
    Current_thread = continuation;
    return continuation; }

NBR_type Thread_Register(CCC_type C_function)
  { NBR_type thread_id;
    if (Thread_counter == Thread_table_size)
      Main_Fatal_Error(TMT_error_string);
    Thread_table[Thread_counter] = C_function;
    thread_id = make_NBR(Thread_counter++);
    return thread_id; }

CCC_type Thread_Retrieve(NBR_type Thread_id)
  { UNS_type raw_thread_id;
    raw_thread_id = get_NBR(Thread_id);
    return Thread_table[raw_thread_id]; }

NIL_type Thread_Zap(NIL_type)
  { Current_thread = Current_thread->cnt; }
